/* ==================================================== */
/* @File class.h                                        */
/* @history:                                            */
/* @+   Jul. 00 <jompo> first draft                     */
/* ==================================================== */

#define DEFAULT_CLASS_DIST	5	/* see outR1 in ClassParams		*/
#define DEFAULT_CLASS_SCORE_SEUIL  40	/* see seuil_score in ClassParams	*/


typedef struct {
   int		outR1;		/* if 1: output also the R1 classes		*/
				/* default value: DEFAULT_CLASS_DIST		*/
   int		nseuil;		/* threshold in number of genes to consider	*/
				/* two genes in the same class			*/
				/* default: DEFAULT_CLASS_DIST (5)		*/
   int		circular;	/* if 1: genome is circular			*/
				/* if 0: genome is linear [Default]		*/
   int		output_singleton;/* if 1: output singletons, default 0: do not	*/
				/* output single couples operon/gene		*/
   int		combi;		/* if 1: combinatoric serach (cf README)       	*/
   int		do_bbh;		/* if 1: output only BBH (double best hits)	*/
   int		bijectif;	/* if 1: a genomic gene can be in relation with	*/
				/* only one operon gene, and vice versa (i.e.	*/
				/* ope1 is in relation with gen1 if gen1 is the	*/
				/* genomic gene most similar to ope1, AND ope1	*/
				/* is the most similar of operon genes to gen1	*/
				/* if 0: an operon gene can be in relation with	*/
				/* two or more genomic gene			*/
				/* default: 0					*/
   int		seuil_score;	/* bestfit score threshold (0-100) for a couple	*/
				/* operon gene/genomic gene to be considered	*/
				/* as homolog (default:70)			*/
   int		operon_class;	/* 1: classes are computed also on operon genes	*/
   int		ope_circular;	/* 1: operon is circular 0: operon is linear   	*/
   float	len_thresh;	/* limit of diff len ratio threshold to be 	*/
				/* homologs					*/

} ClassParam;

/* ----------------------------------------------------	*/
/* Prototype of exported fuctions			*/
/* ----------------------------------------------------	*/

int ComputeR2Classes(OperonSeqPtr *ope, int nb_ope,
			GenomeSeqPtr *gen, int nb_gen,
			int nseuil,
			int operon_classe, 
			int gen_circular, int mingn, int maxgn,
			int ope_circular, int minon, int maxon,
			int verbose);

int ComputeR1Classes(OperonSeqPtr *ope, int nb_ope, int nseuil,
			int operon_circular, int minn, int maxn, int verbose);

void SortAndFilterSingleton(OperonSeqPtr *ope, int nb_ope,
			int filter_singleton);
