/* ------------------------------------------------	*/
/* util.h						*/
/* ------------------------------------------------	*/


#define IS_UPPER(c) 	    (((c) >= 'A') && ((c) <= 'Z'))
#define IS_LOWER(c) 	    (((c) >= 'a') && ((c) <= 'z'))
#define IS_ALPHA(c) 	    (IS_UPPER(c) || IS_LOWER(c))
#define TO_UPPER(c)         ((c) - 'a' + 'A')
#define TO_LOWER(c)         ((c) - 'A' + 'a')


typedef struct {
   int u_cpu_time;		/* cpu in sec	*/
   int nu_cpu_time;		/* cpu in nsec	*/
   int mem_ko;			/* memory in Ko	*/
} MyPs, *MyPsPtr;

int	Erreur		    (char *msg , int stat);
void	MyError(FILE *stream, int stat, char *tag, char *fmt, ...);
int	MemoryErreur	    (char *where, int stat);
int	AssignToStdin	    (char *filename);
int	CheckAccess	    (char *filename, char *mode);
char	*StrTrimLeading	    (char *str);
char	*UpperStr	    (char *str);
char	*LowerStr	    (char *str);
int	DeleteInStr	    (char *str, char *alphabet);
char	*ReplaceInStr	    (char *str, char *alphabet, int repchar);
float	UserCpuTime	    (void);
float	SystemCpuTime	    (void);
float	MemoryArena	    (void);
MyPsPtr GiveProcessStatus(FILE *sterr);

