#!/usr/bin/env python
# -*- coding: utf-8 -*-
###############################################################################
# Some small functions to get the characteristics of the chromosomes of a genomes

import re, os


###################
## USE in Script_SyntenyBlocks

## RETURN le nombre de genes d'une espece 'speciesName' appartenant a un groupe 'organismName'
#def nbGenes(path, speciesName):
#    os.system("grep -c '^gene' "+path+'/01Genomes/'+speciesName+'.def >nb')
#    nb=open('nb','r')
#    k=int(nb.readline())
#    nb.close()
#    os.remove('nb')
#    print('fini')
#    return k

## RETURN 3 lists: the names, the centromere positions, the last feature numbers
# for a given species
def chromosomesLists(path, speciesName):
   chromoFile=open(path+'/01Genomes/'+speciesName+'.ch','r')
   line=chromoFile.readline()
   name=line.split()
   line=chromoFile.readline()
   centro=map(int,line.split())
   line=chromoFile.readline()
   end=map(int,line.split())
   chromoFile.close()
   return name,centro,end


# Return the list of the different .def found in the 01Genomes/ directory
def ListShortName(path):
   ## Genome
   genomesL=os.listdir(path+'/01Genomes/')
   genomesL.sort()
   shortNameList=[]
   for f in genomesL:
      if re.match('(.*)\.def$',f):
         res=re.match('(.*)\.def$',f)
         shortNameList.append(res.group(1))
   return shortNameList


###################
## USE in n04

## RETURN the chromosome number of a given feature number (using the ENDChromo list)
# (return 1 if the feature belongs to the 1st chromo)
def chromosome(i,liste):
   for j in range(len(liste)):
      if i<=int(liste[j]):
         chromo=j+1
         break
   return chromo

## return the length of the longest chromosome
# liste : liste of the last feature number of each chromosome  
def maxLenghtChrom(liste):
   for i in range(len(liste)):
      if i==0:
         maxi=liste[0]
      else:
         maxi=max(maxi,liste[i]-liste[i-1])
   return maxi

