#!/usr/bin/env python
# -*- coding: utf-8 -*-
###############################################################################
# functions that complete the synteny blocks (computed only with RBH)

import re, os, tempfile
import n01Genomes

def orthologsNonBDBHFile(path,shortName1,recapBlocGene1,shortName2,recapBlocGene2,
recapGene1Ortho2,chromoDelimit1,chromoDelimit2,len2,strK,deltaNonRBH,min_sim_nonRBH,min_align):

   delta=int(strK)
   geneInSynthon1=[]
   for nums in recapBlocGene1:
      geneInSynthon1.extend(nums)
   geneInSynthon1=list(set(geneInSynthon1))
   
   fileD=open(path+'/01Genomes/'+shortName2+'.prt','r')
   prt2=[]
   for p in range(len2):
      prt2.append((0,0))
   ligne=fileD.readline()
   while ligne!='':
      entete=(reduce((lambda x,y:x+' '+y),re.split('\t',ligne)))
      ligneList=re.split('\t',ligne)
      p=int(ligneList[8])
      trad=''
      ligne=fileD.readline()
      while not(re.match('>',ligne) or (ligne=='')):
         trad+=ligne
         ligne=fileD.readline()
      prt2[p-1]=(entete,trad)
   fileD.close()
   
   order=shortName1<shortName2
   if order:
      fileNameR=path+'/11Blocks/Delta'+strK+'/RBHBlocks/'+shortName1+'.'+shortName2
      fileNameO=path+'/11Blocks/Delta'+strK+'/OrthBlocks/'+shortName1+'.'+shortName2
   else:
      fileNameR=path+'/11Blocks/Delta'+strK+'/RBHBlocks/'+shortName2+'.'+shortName1
      fileNameO=path+'/11Blocks/Delta'+strK+'/OrthBlocks/'+shortName2+'.'+shortName1
   os.system('cp '+fileNameR+'.rbh.pairs '+fileNameO+'.orth.pairs')
   
   newOrthoPairs=[]
   geneList=open(path+'/01Genomes/'+shortName1+'.prt','r')
   ligne=geneList.readline()
   while ligne!='':
      ligneList=re.split('\t',ligne)
      ligneList[0]=ligneList[0][1:]
      placeInFeatures=int(ligneList[8])
      listClAnch=closeAnchors(deltaNonRBH,placeInFeatures,geneInSynthon1,chromoDelimit1,len(recapGene1Ortho2))
      #this gene is not an anchor but close to
      if listClAnch!=[]:     
         # we get back the sequence       
         sequencef=tempfile.mkstemp()
         sequence=os.fdopen(sequencef[0],'w')       
         sequence.write(ligne)
         ligne=geneList.readline()
         while not(re.match('>',ligne) or (ligne=='')):
            sequence.write(ligne)
            ligne=geneList.readline()
         sequence.close()
         
         # we look for its ortholog
         ancreortho=defDataBase(listClAnch,recapGene1Ortho2,deltaNonRBH,len2,chromoDelimit2)
         dataBf=tempfile.mkstemp()              
         dataB=os.fdopen(dataBf[0],'w')       
         for ao in ancreortho:
            if prt2[ao-1]!=(0,0):
               dataB.write(prt2[ao-1][0]+prt2[ao-1][1])
         dataB.close()
         os.chdir(path+'/01Genomes')
         os.system("formatdb -i "+dataBf[1]+" -p T")
         sortief=tempfile.mkstemp()       
         os.system("blastall -p blastp -d "+dataBf[1]+" -i "+sequencef[1]+" -o "+sortief[1])
         os.chdir('../../Programs/1SynChro')
         
         # we get a list of orthologs
         orthoList=orthologsList(sortief,min_sim_nonRBH,min_align)
         newOrthoPairs.append([ligneList,orthoList])
         
         os.remove(sequencef[1])
         os.remove(dataBf[1])
         os.remove(sortief[1])
         os.remove(dataBf[1]+'.phr') if os.path.exists(dataBf[1]+'.phr') else None
         os.remove(dataBf[1]+'.pin') if os.path.exists(dataBf[1]+'.pin') else None
         os.remove(dataBf[1]+'.psq') if os.path.exists(dataBf[1]+'.psq') else None
      else:
         ligne=geneList.readline()
         while not(re.match('>',ligne) or (ligne=='')):
            ligne=geneList.readline()
   geneList.close()
   print('PairsFile Modification')
   pairs=open(fileNameO+'.orth.pairs','a')
   for orthoCouples in newOrthoPairs:
      gene1=orthoCouples[0]
      genes2=orthoCouples[1]
      for gene2 in genes2:
         if int(gene2[9])>100:
            print gene2
         if gene1[5]!=gene2[5]:
            signe='invert'
         else:
            signe='sameW'
         if order:
            pairs.write(gene1[0]+(' %03d'%int(gene1[1]))+' 00000 '+('%05d '%int(gene1[7]))+('%05d '% int(gene1[8]))+gene2[0]+(' %03d'%int(gene2[1]))+' 00000 '+('%05d'%int(gene2[7]))+(' %05d '% int(gene2[8]))+('%02d '%int(gene2[9]))+signe+'\n')
         else:
            pairs.write(gene2[0]+(' %03d'%int(gene2[1]))+' 00000 '+('%05d '%int(gene2[7]))+('%05d '% int(gene2[8]))+gene1[0]+(' %03d'%int(gene1[1]))+' 00000 '+('%05d'%int(gene1[7]))+(' %05d '% int(gene1[8]))+('%02d '%int(gene2[9]))+signe+'\n')
   pairs.close()
   tempo=tempfile.mkstemp()[1]       
   os.system('sort -u -k 1,10 '+fileNameO+'.orth.pairs'+' | sort -g -k 5 -k 10 > '+tempo)
   os.system('cp '+tempo+' '+fileNameO+'.orth.pairs')
   os.remove(tempo)

def orthologsNonBDBHDico(path,shortName1,shortName2,strK):
   pairs=open(path+'/11Blocks/Delta'+strK+'/OrthBlocks/'+shortName1+'.'+shortName2+'.orth.pairs','r')
   newPairOfOrthoDico={}
   for ligne in pairs:
      if re.search(' 00000 ',ligne):
         res=re.search(' 00000 (\d*) (\d*) .* 00000 (\d*) (\d*) (\d*) (.*)',ligne)
         newPairOfOrthoDico[(int(res.group(2)),int(res.group(4)))]=(int(res.group(5)),res.group(6))
   pairs.close()
   return newPairOfOrthoDico



# renvoie la ligne du .prt file of the orthologs sequences and the respective percentage of similarity
def orthologsList(fileN,min_sim_nonRBH,min_align):
   resultFile=os.fdopen(fileN[0],'r')
   orthoList=[]
   ligne=resultFile.readline()
   while not(re.search('\((\d*) letters\)',ligne) or (ligne=='')):
      ligne=resultFile.readline()
   if not re.search('\((\d*) letters\)',ligne):
      resultFile.close()
      return []
   res=re.search('\((\d*) letters\)',ligne)
   lenQuery=int(res.group(1))
   while ligne!='':
      while not(re.match('>',ligne) or (ligne=='')):
         ligne=resultFile.readline()
      if ligne=='':
         break
      else:                
         ligneList=re.split(" ",ligne)           # ligne that describes the orthologs
         ligneList[0]=ligneList[0][1:]
         ligne=resultFile.readline()              # ligne with 'Lenght'
         if not re.search('Length = (\d*)',ligne):
            ligneL=re.split("( *)",ligne)
            for i in range(1,len(ligneL)/2+1):
               ligneList.append(ligneL[i*2])
            ligne=resultFile.readline()
         res=re.search('Length = (\d*)',ligne)
         lenSbjct=int(res.group(1))
         lalignmt=0
         nbpos=0
         while not(re.match('>',ligne) or (ligne=='')):
            while not(re.search('Positives = (\d*)\/(\d*) \((\d*)\%\)',ligne) or re.match('>',ligne) or (ligne=='')):
               ligne=resultFile.readline()
            if re.search('Positives = (\d*)\/(\d*) \((\d*)\%\)',ligne):
               res=re.search('Positives = (\d*)\/(\d*) \((\d*)\%\)',ligne)
               lalignmt+=int(res.group(2))
               nbpos+=int(res.group(1))
               ligne=resultFile.readline()
         percentAlign=float(lalignmt)/min(lenSbjct,lenQuery)
         percentSimil=float(nbpos)/lalignmt
         if (percentAlign>min_align) and (percentSimil>min_sim_nonRBH):
            if percentSimil>1:
               print percentSimil
            ligneList.append(percentSimil*100)
            orthoList.append(ligneList)
   resultFile.close()
   return orthoList


# return the list of the close anchors              
def closeAnchors(delta,x,ancresList,endChromo,len1):
   res=[]
   chrom=n01Genomes.chromosome(x,endChromo)
   if x not in ancresList:
      start=x-delta
      end=x+delta
      if start<=0:
         start=1
      if end>len1:
         end=len1
      for i in range(start,end+1):
         if i in ancresList:
            if n01Genomes.chromosome(i,endChromo)==chrom:
               res.append(i)
   return res

# return the gene list of G2 to put in the database
def defDataBase(listClAnch,recapGene1Ortho2,delta,len2,endChromo):
   genes2=[]
   for x in listClAnch:
      genes2.append(recapGene1Ortho2[x-1])
   res=[]
   for x in genes2:
      chr=n01Genomes.chromosome(x,endChromo)
      start=x-delta
      end=x+delta
      if start<=0:
         start=1
      if end>len2:
         end=len2
      for i in range(start,end+1):
         if n01Genomes.chromosome(i,endChromo)==chr:
            res.append(i)
   return list(set(res))

        
#def numFeatures(delta,codeList,x):
    #i=0
    #j=0
    #while i<abs(delta):
       #j+=delta/abs(delta)
       #if x-1+j<len(codeList):
           #potential=codeList[x-1+j]
       #else:
           #break
       #if potential=='gene' or potential=='geneSW' or potential=='geneDW':
           #i+=1
    #return x+j


def blocUnik(fileStartEnd,fileSynthon,newPairOfOrthoDico):
   startEnd=open(fileStartEnd,"r")
   synthon=open(fileSynthon,"r")
   newStartEnd=open("newStartEnd","w")
   newSynthon=open("newSynthon","w")

   lgSE=startEnd.readline()
   lstSE=re.split(" ",lgSE)  
   lgS=synthon.readline()

   while lgSE!="" and lgS!="" :
      if ((lstSE[1]!=lstSE[5] and lstSE[3]!=lstSE[7]) and
       (int(lstSE[8])!=2 or not
       (newPairOfOrthoDico.has_key((int(lstSE[1]),int(lstSE[3])))
       and newPairOfOrthoDico.has_key((int(lstSE[5]),int(lstSE[7])))))):
         newStartEnd.write(lgSE)
         newSynthon.write(lgS)
      lgSE=startEnd.readline()
      lstSE=re.split(" ",lgSE)  
      lgS=synthon.readline()

   startEnd.close()
   synthon.close()
   newStartEnd.close()
   newSynthon.close()

   os.system('cp newStartEnd '+fileStartEnd)
   os.system('cp newSynthon '+fileSynthon)
   os.remove('newStartEnd')
   os.remove('newSynthon') 
