#!/usr/bin/env python
# -*- coding: utf-8 -*-
###############################################################################
# functions that recap the synteny blocks (return detailed lists)

import re,os

def recapitulatifList(path,genome1,genome2,step,strK):

   order=(genome1<genome2)
   if order:
      nameFile=genome1+'.'+genome2
   else:
      nameFile=genome2+'.'+genome1
   orthologs=open(path+'/10RBH/'+nameFile+'.opsc.shrt', 'r')
   if step==1:
      syntons=open(path+'/11Blocks/Delta'+strK+'/RBHBlocks/'+nameFile+'.rbh.synt','r')
   elif step==2:
      syntons=open(path+'/11Blocks/Delta'+strK+'/OrthBlocks/'+nameFile+'.orth.synt','r')
   else:
      syntons=open(path+'/4Ancestors/'+nameFile+'/Delta'+strK+'/OrthBlocks/'+nameFile+'.orth.synt','r')
   print(path+'/11Blocks/Delta'+strK+'/RBHBlocks/'+nameFile+'.rbh.synt')

   
   posAbsoluGene1=[]  # reel position of the genes in the genome
   posAbsoluGene2=[]    
   nameListGenome1=[] # complete list of name of all features of genome1
   nameListGenome2=[]
   codeListGenome1=[] # complete list of the feature for the representation LTR, GDortho, tRNA, ...
   codeListGenome2=[]
   recapBlocGene1=[]  # list of lists of synthons with the absolute position of genes 1
   recapBlocGene2=[]
   recapGene1Ortho2=[]# complete list of orthologs 2 for gene 1 (position in whole genome 2)
   recapGene2Ortho1=[]

   ## we fill all these lists ...
   # posAbsoluGene and nameListGenome
   (posAbsoluGene1,nameListGenome1,codeListGenome1)=absolutePos(path,genome1)
   (posAbsoluGene2,nameListGenome2,codeListGenome2)=absolutePos(path,genome2)

   recapSimilarityG1=[0]*len(codeListGenome1)  # rate of similarity for the pair of genes orthologs
   recapSimilarityG2=[0]*len(codeListGenome2)
   recapGene1Ortho2=[0]*len(codeListGenome1)
   recapGene2Ortho1=[0]*len(codeListGenome2)

   # codeListGenome
   for ligne in orthologs:
      ligneList=ligne.split()
      if order:
         posAbsolu1=int(ligneList[3])
         posAbsolu2=int(ligneList[7])
      else:
         posAbsolu1=int(ligneList[7])
         posAbsolu2=int(ligneList[3])
      recapGene1Ortho2[posAbsolu1-1]=posAbsolu2
      recapGene2Ortho1[posAbsolu2-1]=posAbsolu1
      if ligneList[10]=='sameW':
         codeListGenome1[posAbsolu1-1]='geneSW'
         codeListGenome2[posAbsolu2-1]='geneSW'
      else:
         codeListGenome1[posAbsolu1-1]='geneDW'
         codeListGenome2[posAbsolu2-1]='geneDW'

   # recapBlocGene
   i=1
   for ligne in syntons:
      ligneList=ligne.split()
      recapBlocGene1.append([])
      recapBlocGene2.append([])
      for j in range(len(ligneList)/5):
         if order:
            posAbsolu1=int(ligneList[5*j+3])
            posAbsolu2=int(ligneList[5*j+5])
         else:
            posAbsolu1=int(ligneList[5*j+5])
            posAbsolu2=int(ligneList[5*j+3])
         recapBlocGene1[i-1].append(posAbsolu1)  # we fill recap
         recapBlocGene2[i-1].append(posAbsolu2)
         recapSimilarityG1[posAbsolu1-1]=ligneList[5*j+6]
         recapSimilarityG2[posAbsolu2-1]=ligneList[5*j+6]
      i+=1
   orthologs.close()
   syntons.close()
   return nameListGenome1,nameListGenome2,codeListGenome1,codeListGenome2,\
recapBlocGene1,recapBlocGene2,recapSimilarityG1,recapSimilarityG2,\
recapGene1Ortho2,recapGene2Ortho1


def absolutePos(path,genome):
   defGenome=open(path+'/01Genomes/'+genome+'.def','r')
   defGenome.readline() #headline
   posList=[]
   nameList=[]
   featureList=[]
   for feature in defGenome:
      lis=feature.split()
      nameList.append(lis[1])
      featureList.append(lis[0])
      if lis[0]=='gene':
         posList.append(int(lis[9]))
   defGenome.close()
   return posList,nameList,featureList


def startEnd(path,name,organism):
   filesL=os.listdir('../../'+organism+'/01Genomes/')
   filesL.sort()
   dicosGenes={}
   for f in filesL:
      if re.match('\w+\.def',f):
         res=re.match('(\w+)\.def',f)
         genome=res.group(1)
         dicosGenes[genome]={}
         ## a dictio of gene coordinates / genome
         fileO=open('../../'+organism+'/01Genomes/'+genome+'.def','r')
         fileO.readline()
         for ligne in fileO:
            ligneL=ligne.split()
            dicosGenes[genome][int(ligneL[-1])]=(ligneL[1],int(ligneL[-2]),(int(ligneL[3]),int(ligneL[4])))
         fileO.close()
   filesL=os.listdir(path)
   filesL.sort()
   for f in filesL:
      if re.match('\w+\.\w+\.'+name+'\.synt$',f):
         res=re.match('(\w+)\.(\w+)\.'+name+'\.synt',f)
         name1=res.group(1)
         name2=res.group(2)
         if name1 in dicosGenes and name2 in dicosGenes:
            syntons=open(path+f,'r')
            se=open(path+name1+'.'+name2+'.'+name+'.synt.start_end','w')
            for ligne in syntons:
               ligneList=ligne.split()
               recapBlocGene1=[]
               recapBlocGene2=[]
               for j in range(len(ligneList)/5):
                  recapBlocGene1.append(int(ligneList[5*j+3]))  # we fill recap
                  recapBlocGene2.append(int(ligneList[5*j+5]))

               mini1,maxi1=min(recapBlocGene1),max(recapBlocGene1)
               mini2,maxi2=min(recapBlocGene2),max(recapBlocGene2)
               nbAncres=str(len(recapBlocGene1))
               nbGen1=str(dicosGenes[name1][maxi1][1]-dicosGenes[name1][mini1][1]+1)
               nbGen2=str(dicosGenes[name2][maxi2][1]-dicosGenes[name2][mini2][1]+1)
               
               se.write(ligneList[0]+'\t'+ligneList[1]+'\t'+dicosGenes[name1][mini1][0]+
               "\t%05d\t"%dicosGenes[name1][mini1][1]+"%05d\t"%mini1+
               "%d\t"%dicosGenes[name1][mini1][2][0]+
               dicosGenes[name1][maxi1][0]+
               "\t%05d\t"%dicosGenes[name1][maxi1][1]+"%05d\t"%maxi1+
               "%d\t"%dicosGenes[name1][maxi1][2][1]+
               nbGen1+'\t'+
               dicosGenes[name2][mini2][0]+
               "\t%05d\t"%dicosGenes[name2][mini2][1]+"%05d\t"%mini2+
               "%d\t"%dicosGenes[name2][mini2][2][0]+
               dicosGenes[name2][maxi2][0]+
               "\t%05d\t"%dicosGenes[name2][maxi2][1]+"%05d\t"%maxi2+
               "%d\t"%dicosGenes[name2][maxi2][2][1]+
               nbGen2+'\t'+nbAncres+'\n')
            syntons.close()
            se.close()

