#!/usr/bin/env python 
# -*- coding: utf-8 -*-
###############################################################################
# functions that draw the Synteny Map

from re import *
import n01Genomes


def header(out,w,h):
   out.write('''<?xml version="1.0" standalone="no"?>
   <svg width="%d" height="%d"
   xmlns="http://www.w3.org/2000/svg" version="1.1"
   xmlns:xlink="http://www.w3.org/1999/xlink">'''%(w,h))

## draw the structure/lines of both genomes
def drawLegende(out):
   y=INTERVALY
   x=10*INTERVALX
   out.write('''    <circle cx="%d" cy="%d" r="%d" fill="%s" stroke="%s" stroke-width="2" />'''%(x,y,RAYON,'#003300','#003300'))
   x=x+INTERVALX
   out.write('''    <circle cx="%d" cy="%d" r="%d" fill="%s" stroke="%s" stroke-width="2" />'''%(x,y,RAYON,'#006600','#006600'))
   x=x+INTERVALX
   out.write('''    <circle cx="%d" cy="%d" r="%d" fill="%s" stroke="%s" stroke-width="2" />'''%(x,y,RAYON,'#009900','#009900'))
   x=x+INTERVALX
   out.write('''    <circle cx="%d" cy="%d" r="%d" fill="%s" stroke="%s" stroke-width="2" />'''%(x,y,RAYON,'#00CC33','#00CC33'))
   x=x+INTERVALX
   out.write('''    <circle cx="%d" cy="%d" r="%d" fill="%s" stroke="%s" stroke-width="2" />'''%(x,y,RAYON,'#00FF00','#00FF00'))
   x=x+INTERVALX
   out.write('''    <circle cx="%d" cy="%d" r="%d" fill="%s" stroke="%s" stroke-width="2" />'''%(x,y,RAYON,'#00FF33','#00FF33'))
   x=x+INTERVALX
   out.write('''    <circle cx="%d" cy="%d" r="%d" fill="%s" stroke="%s" stroke-width="2" />'''%(x,y,RAYON,'#00FF66','#00FF66'))
   x=x+INTERVALX
   out.write('''    <circle cx="%d" cy="%d" r="%d" fill="%s" stroke="%s" stroke-width="2" />'''%(x,y,RAYON,'#00FF99','#00FF99'))
   x=x+INTERVALX
   out.write('''    <text x="%d" y="%d" font-family="Verdana" font-size="10" fill="green" > non inverted orthologs (RBH): from darkest (&gt; 90 &#37; similarity) to lightest ones (&lt; 30 &#37; similarity)
      </text>'''%(x,y))
   x=x+50*INTERVALX
   out.write('''    <circle cx="%d" cy="%d" r="%d" fill="%s" stroke="%s" stroke-width="2" />'''%(x,y,RAYON,'#CC0000','#FF0000'))
   x=x+INTERVALX
   out.write('''    <circle cx="%d" cy="%d" r="%d" fill="%s" stroke="%s" stroke-width="2" />'''%(x,y,RAYON,'#FF0000','#FF0033'))
   x=x+INTERVALX
   out.write('''    <circle cx="%d" cy="%d" r="%d" fill="%s" stroke="%s" stroke-width="2" />'''%(x,y,RAYON,'#FF0066','#FF0066'))
   x=x+INTERVALX
   out.write('''    <circle cx="%d" cy="%d" r="%d" fill="%s" stroke="%s" stroke-width="2" />'''%(x,y,RAYON,'#FF0099','#FF0099'))
   x=x+INTERVALX
   out.write('''    <circle cx="%d" cy="%d" r="%d" fill="%s" stroke="%s" stroke-width="2" />'''%(x,y,RAYON,'#FF00CC','#FF00CC'))
   x=x+INTERVALX
   out.write('''    <circle cx="%d" cy="%d" r="%d" fill="%s" stroke="%s" stroke-width="2" />'''%(x,y,RAYON,'#FF33CC','#FF33CC'))
   x=x+INTERVALX
   out.write('''    <circle cx="%d" cy="%d" r="%d" fill="%s" stroke="%s" stroke-width="2" />'''%(x,y,RAYON,'#FF66CC','#FF66CC'))
   x=x+INTERVALX
   out.write('''    <circle cx="%d" cy="%d" r="%d" fill="%s" stroke="%s" stroke-width="2" />'''%(x,y,RAYON,'#FF99CC','#FF99CC'))
   x=x+INTERVALX
   out.write('''    <text x="%d" y="%d" font-family="Verdana" font-size="10" fill="red" > inverted orthologs (RBH): from darkest (&gt; 90 &#37; similarity) to lightest ones (&lt; 30 &#37; similarity)
      </text>'''%(x,y))
   x=x+50*INTERVALX
   out.write('''    <circle cx="%d" cy="%d" r="%d" fill="blue" stroke="blue" stroke-width="2" />'''%(x,y,RAYON))
   x=x+INTERVALX
   out.write('''    <text x="%d" y="%d" font-family="Verdana" font-size="10" fill="blue" > genes without 'RBH' orthologs
      </text>'''%(x,y))
   x=x+15*INTERVALX
   out.write('''    <line x1="%d" y1="%d" x2="%d" y2="%d" stroke-width="1.6" stroke="green" /> '''%(x,y,x+3*INTERVALX,y))
   x=x+4*INTERVALX
   out.write('''    <text x="%d" y="%d" font-family="Verdana" font-size="10" fill="black" > links between 2 RBH genes
      </text>'''%(x,y))
   x=x+15*INTERVALX
   out.write('''    <line x1="%d" y1="%d" x2="%d" y2="%d" stroke-dasharray="6 6" stroke-width="1.6" stroke="red" /> '''%(x,y,x+3*INTERVALX,y))
   x=x+4*INTERVALX
   out.write('''    <text x="%d" y="%d" font-family="Verdana" font-size="10" fill="black" > links between ortologs non RBH linked
      </text>'''%(x,y))
   x=x+18*INTERVALX
   out.write('''    <circle cx="%d" cy="%d" r="%d" fill="white" stroke="black" stroke-width="2" />'''%(x,y,RAYON))
   x=x+INTERVALX
   out.write('''    <text x="%d" y="%d" font-family="Verdana" font-size="10" fill="black" > Pseudo-genes 
      </text>'''%(x,y))
   x=x+10*INTERVALX
   out.write('''    <rect x="%d" y="%d" width="%d" height="%d" fill="white" stroke="black" stroke-width="2" />'''%(x,y,RAYON,2*RAYON))
   x=x+INTERVALX
   out.write('''    <text x="%d" y="%d" font-family="Verdana" font-size="10" fill="black" > LTRs 
      </text>'''%(x,y))
   x=x+4*INTERVALX
   out.write('''    <rect x="%d" y="%d" width="%d" height="%d" fill="black" stroke="black" stroke-width="2" />'''%(x,y,RAYON/3,2*RAYON))
   out.write('''    <rect x="%d" y="%d" width="%d" height="%d" fill="black" stroke="black" stroke-width="2" />'''%(x+5/3*RAYON,y,RAYON/3,2*RAYON))
   x=x+INTERVALX
   out.write('''    <text x="%d" y="%d" font-family="Verdana" font-size="10" fill="black" > Repeat Regions 
      </text>'''%(x,y))      
   x=x+10*INTERVALX
   out.write('''    <rect x="%d" y="%d" width="%d" height="%d" fill="black" stroke="black" stroke-width="2" />'''%(x,y,RAYON,2*RAYON))
   x=x+INTERVALX
   out.write('''    <text x="%d" y="%d" font-family="Verdana" font-size="10" fill="black" > tRNA
      </text>'''%(x,y))
   x=x+4*INTERVALX
   out.write('''    <circle cx="%d" cy="%d" r="%d" fill="black" stroke="black" stroke-width="2" />'''%(x,y,RAYON/2))
   x=x+INTERVALX
   out.write('''    <text x="%d" y="%d" font-family="Verdana" font-size="10" fill="black" > rRNA 
      </text>'''%(x,y))
   x=x+4*INTERVALX
   out.write('''    <circle cx="%d" cy="%d" r="%d" fill="white" stroke="black" stroke-width="2" />'''%(x,y,RAYON/2))
   x=x+INTERVALX
   out.write('''    <text x="%d" y="%d" font-family="Verdana" font-size="10" fill="black" > ncRNA
      </text>'''%(x,y))
   x=x+5*INTERVALX
   out.write('''    <circle cx="%d" cy="%d" r="%d" fill="black" stroke="black" stroke-width="2" />'''%(x,y,2*RAYON))
   x=x+INTERVALX
   out.write('''    <text x="%d" y="%d" font-family="Verdana" font-size="10" fill="black" > centromeres
      </text>'''%(x,y))


## draw the structure/lines of both genomes
def drawStucture(out,Level,shortName1,nbCh1,nbCh2,chromNumber1,shortName2='',chromName1=[],chromName2=[]):
   x=10
   print nbCh1, chromNumber1
   for i in range(nbCh1):
      # the name of the chromosome 1
      if chromName1==[]:
         chName1=i+1
      else:
         chName1=chromName1[i]
      xi=x
      yi=(i+1)*Level
      out.write('''    <text x="%d" y="%d" font-family="Verdana" font-size="16" fill="black" > '''%(xi,yi)+shortName1+' chr '+str(chName1)+''' 
      </text>''')
      # the lines of chromosome 1
      if i==0:
         previous=0
      else:
         previous=chromNumber1[i-1]    
      X1i=NAMELEN
      Y1i=yi
      X2i=X1i+INTERVALX*(chromNumber1[i]-previous)   #chromNumber is the the number of genes for each chromosome
      Y2i=yi
      out.write('''    <line x1="%d" y1="%d" x2="%d" y2="%d" stroke-width="1.6" stroke="black" />'''%(X1i,Y1i,X2i,Y2i))
      for j in range(nbCh2):
         # the name of the chromosome 2
         if chromName2==[]:
            chName2=j+1
         else:
            chName2=chromName2[j]
         xj=x
         yj=yi+INTERVALY*(j-nbCh2)
         out.write('''    <text x="%d" y="%d" font-family="Verdana" font-size="12" fill="black" > '''%(xj,yj)+shortName2+' chr '+chName2+''' 
      </text>''')
         # the lines of chromosome 2
         X1j=X1i
         Y1j=yj
         X2j=X2i
         Y2j=yj
         out.write('''    <line x1="%d" y1="%d" x2="%d" y2="%d" stroke-width="0.4" stroke="black" />'''%(X1j,Y1j,X2j,Y2j))

def colorRed(similar):
   if similar<30:
      color="#FF99CC"
   elif similar<40:
      color="#FF66CC"
   elif similar<50:
      color="#FF33CC"
   elif similar<60:
      color="#FF00CC"
   elif similar<70:
      color="#FF0099"
   elif similar<80:
      color="#FF0066"
   elif similar<90:
      color="#FF0000"
   elif similar<=100:
      color="#CC0000"
   return color

def colorGreen(similar):
   if similar<30:
      color="#00FF99"
   elif similar<40:
      color="#00FF66"
   elif similar<50:
      color="#00FF33"
   elif similar<60:
      color="#00FF00"
   elif similar<70:
      color="#00CC33"
   elif similar<80:
      color="#009900"
   elif similar<90:
      color="#006600"
   elif similar<=100:
      color="#003300"
   return color

## draw the genome 1 with different colors and forms
def drawGenome1(k,out,Level,codeListGenome1,chromNumber1,centroNumber1,
                nameListGenome1,recapSimilarityG1,genome=1,xStart=0,yStart=0,
                superposition=[],lenBloc1=0):
   centromere=0
   graphPositionFeature1=[]
   if genome==2:
      textH=-INTERVALY/3
      xi=xStart
      xFin2=xStart+(len(codeListGenome1)-1)*INTERVALX
      xFin1=xStart+(lenBloc1-1)*INTERVALX
      if ([xStart,yStart] in superposition or
            [xFin1,yStart] in superposition or
            [xFin2,yStart] in superposition):
         if ([xStart,yStart-INTERVALY/3]in superposition or
               [xFin1,yStart-INTERVALY/3] in superposition or
               [xFin2,yStart] in superposition):
            yi=yStart+INTERVALY/3
         else:
            yi=yStart-INTERVALY/3
      else:
         yi=yStart
   for i in range(len(codeListGenome1)):
         color='' 
         feature=codeListGenome1[i]

         if genome==1:
            textH=3*INTERVALY/5
            chrom=n01Genomes.chromosome(i+1,chromNumber1)
            if i+1<centroNumber1[chrom-1]:
               centromere=0
            else:
               centromere=1
            yi=Level+(chrom-1)*Level
            if chrom==1:
               previous=0
            else:
               previous=chromNumber1[chrom-2]
            xi=NAMELEN+(i-previous)*INTERVALX

         else:
            xi=xStart+i*INTERVALX

         out.write(''' <a xlink:href="http://www.genolevures.org/elt/%s/%s"> '''%(nameListGenome1[i][0:4],nameListGenome1[i]))
         
         if feature=='geneDW':
               similar=int(recapSimilarityG1[i])
               color=colorRed(similar)
               out.write('''    <circle id="geneDW%d" cx="%d" cy="%d" r="%d" fill="%s" stroke="%s" stroke-width="0.2" />'''%(k+i,xi,yi,RAYON,color,color))
         elif feature=='gene':
               if recapSimilarityG1==[]:
                  color='black'
               else:
                  color='blue'
               out.write('''    <circle id="gene%d" cx="%d" cy="%d" r="%d" fill="%s" stroke="%s" stroke-width="0.2" />'''%(k+i,xi,yi,RAYON,color,color))
         elif feature=='geneSW':
            similar=int(recapSimilarityG1[i])
            color=colorGreen(similar)
            out.write('''    <circle id="geneSW%d" cx="%d" cy="%d" r="%d" fill="%s" stroke="%s" stroke-width="0.2" />'''%(k+i,xi,yi,RAYON,color,color))          
         elif feature=='pseudoG':
            out.write('''    <circle id="pseudoG%d" cx="%d" cy="%d" r="%d" fill="white" stroke="black" stroke-width="0.4" />'''%(k+i,xi,yi,RAYON))
         elif feature=='retroT':
            out.write('''    <rect id="LTR%d" x="%d" y="%d" width="%d" height="%d" fill="white" stroke="black" stroke-width="0.4" />'''%(k+i,xi-RAYON/2,yi-RAYON/2,RAYON,RAYON))
         elif feature=='LTR':
            out.write('''    <rect id="LTR%d" x="%d" y="%d" width="%d" height="%d" fill="white" stroke="black" stroke-width="0.4" />'''%(k+i,xi-RAYON/2,yi-RAYON,RAYON,2*RAYON))
         elif feature=='repeatR':
            out.write('''    <rect id="repeatR%d" x="%d" y="%d" width="%d" height="%d" fill="black" stroke="black" stroke-width="0.2" />'''%(k+i,xi-RAYON,yi-RAYON,RAYON/3,2*RAYON))
            out.write('''    <rect id="repeatR%d" x="%d" y="%d" width="%d" height="%d" fill="black" stroke="black" stroke-width="0.2" />'''%(k+i,xi-RAYON+5/3*RAYON,yi-RAYON,RAYON/3,2*RAYON))
         elif feature=='tRNA':
            out.write('''    <rect id="tRNA%d" x="%d" y="%d" width="%d" height="%d" fill="black" stroke="black" stroke-width="0.2" />'''%(k+i,xi-RAYON/2,yi-RAYON,RAYON,2*RAYON))
         elif feature=='rRNA':
            out.write('''    <circle id="rRNA%d" cx="%d" cy="%d" r="%d" fill="black" stroke="black" stroke-width="0.2" />'''%(k+i,xi,yi,RAYON/2))
         elif feature=='ncRNA':
            out.write('''    <circle id="ncRNA%d" cx="%d" cy="%d" r="%d" fill="white" stroke="black" stroke-width="0.2" />'''%(k+i,xi,yi,RAYON/2))
         elif feature=='centromere':
            out.write('''    <circle id="centromere%d" cx="%d" cy="%d" r="%d" fill="black" stroke="black" stroke-width="0.2" />'''%(k+i,xi,yi,2*RAYON))
         else:
            break
         out.write(''' </a>''') 
         out.write('''    <text x="%d" y="%d" font-size="0">%s %d
                     <set attributeName="font-size" from="0" to="80" 
                           begin="%s%d.mouseover" end="%s%d.mouseout"/>
                 </text>'''%(xi+1.5*INTERVALX,yi+textH,nameListGenome1[i],i+1,feature,k+i,feature,k+i))
         graphPositionFeature1.append([xi,yi,color,centromere])
         if genome==2 and (i>lenBloc1-1 or i==0):
            superposition.append([xi,yi])
   return graphPositionFeature1,k+i,superposition

## dessine les orthos du genome 2 et les liens, ainsi que les blocs de syntheny
def drawGenome2(k,out,Level,recapBlocGene1,graphPositionFeature1,recapBlocGene2,
                codeListGenome2,chromNumber2,centroNumber2,nameListGenome2,
                recapSimilarityG2,newPairOfOrthoDico,order,newPairOfHomo3Dico={}):
   superpos=[]
   # draw the genome 2
   for i in range(len(recapBlocGene2)):
      synthon1=recapBlocGene1[i]
      minSynthon1=min(synthon1)
      maxSynthon1=max(synthon1)
      synthon2=recapBlocGene2[i]
      minSynthon2=min(synthon2)
      maxSynthon2=max(synthon2)
      xGenome2=graphPositionFeature1[minSynthon1-1][0]
      ch2=n01Genomes.chromosome(synthon2[0],chromNumber2)
      yGenome2=graphPositionFeature1[minSynthon1-1][1]+INTERVALY*(ch2-len(chromNumber2)-1)

      featureSubList2=[]
      nameSubListGenome2=[]
      recapSimilaritySubG2=[]

      centromere1=graphPositionFeature1[synthon1[0]-1][3]
      if synthon2[0]<centroNumber2[ch2-1]:
         centromere2=0
      else:
         centromere2=1

      for j in range(0,maxSynthon2-minSynthon2+1):
         if ((centromere1==0 and centromere2==0) or (centromere1==1 and centromere2==1)):
            featureSubList2.append(codeListGenome2[minSynthon2-1+j])
            nameSubListGenome2.append(nameListGenome2[minSynthon2-1+j])
            recapSimilaritySubG2.append(recapSimilarityG2[minSynthon2-1+j])
         else:
            featureSubList2.append(codeListGenome2[maxSynthon2-1-j])
            nameSubListGenome2.append(nameListGenome2[maxSynthon2-1-j])
            recapSimilaritySubG2.append(recapSimilarityG2[maxSynthon2-1-j])
      (graphPositionFeature2,k,superpos)=drawGenome1(k+1,out,Level,featureSubList2,
                                                      chromNumber2,centroNumber2,
                                                      nameSubListGenome2,recapSimilaritySubG2,
                                                      genome=2,xStart=xGenome2,yStart=yGenome2,
                                                      superposition=superpos,
                                                      lenBloc1=maxSynthon1-minSynthon1+1)

      # link genes 1 with genes2
      for j in range(len(synthon1)):
         synt1=synthon1[j]
         synt2=synthon2[j]
         x1=graphPositionFeature1[synt1-1][0]
         y1=graphPositionFeature1[synt1-1][1]
         if ((centromere1==0 and centromere2==0) or (centromere1==1 and centromere2==1)):
            x2=graphPositionFeature2[synt2-minSynthon2][0]
            y2=graphPositionFeature2[synt2-minSynthon2][1]
            color=graphPositionFeature2[synt2-minSynthon2][2]
         else:
            x2=graphPositionFeature2[maxSynthon2-synt2][0]
            y2=graphPositionFeature2[maxSynthon2-synt2][1]
            color=graphPositionFeature2[maxSynthon2-synt2][2]
         if (order and newPairOfHomo3Dico.has_key((synt1,synt2))) or (not order and newPairOfHomo3Dico.has_key((synt2,synt1))):
            if order:
               signe=newPairOfHomo3Dico[(synt1,synt2)]
            else:
               signe=newPairOfHomo3Dico[(synt2,synt1)]
            if signe=='sameW':
               color='green'
            else:
               color='red'
            out.write('''    <line x1="%d" y1="%d" x2="%d" y2="%d" stroke-dasharray="4 6" stroke-width="1.5" stroke="%s" />'''%(x1,y1,x2,y2,color))
         elif (order and newPairOfOrthoDico.has_key((synt1,synt2))) or (not order and newPairOfOrthoDico.has_key((synt2,synt1))):
            if order:
               (similar,signe)=newPairOfOrthoDico[(synt1,synt2)]
            else:
               (similar,signe)=newPairOfOrthoDico[(synt2,synt1)]
            if signe=='sameW':
               color=colorGreen(similar)
            else:
               color=colorRed(similar)
            out.write('''    <line x1="%d" y1="%d" x2="%d" y2="%d" stroke-dasharray="10 12" stroke-width="1.5" stroke="%s" />'''%(x1,y1,x2,y2,color))
         else:
            out.write('''    <line x1="%d" y1="%d" x2="%d" y2="%d" stroke-width="1.5" stroke="%s" />'''%(x1,y1,x2,y2,color))

      ## draw the boxes
      xb1=graphPositionFeature1[minSynthon1-1][0]-LARGEUR
      yb1=graphPositionFeature1[minSynthon1-1][1]-HAUTEUR/2.
      widthb1=(maxSynthon1-minSynthon1)*INTERVALX+2*LARGEUR
      out.write('''    <rect x="%d" y="%d" width="%d" height="%d" fill="none" stroke="black" stroke-width="1" />'''%(xb1,yb1,widthb1,HAUTEUR))

      xb2=graphPositionFeature2[0][0]-LARGEUR
      yb2=graphPositionFeature2[0][1]-HAUTEUR/2.
      widthb2=(len(graphPositionFeature2)-1)*INTERVALX+2*LARGEUR
      out.write('''    <rect x="%d" y="%d" width="%d" height="%d" fill="none" stroke="black" stroke-width="1" />'''%(xb2,yb2,widthb2,HAUTEUR))

def drawInterBlocs1(out,graphPositionFeature1,finalInterBlocs):
   graphPositionFeature2=[]
   for interBloc in finalInterBlocs:
      debut=interBloc[0]
      fin=interBloc[1]
      x1=graphPositionFeature1[debut-1][0]+LARGEUR
      y1=graphPositionFeature1[debut-1][1]-HAUTEUR/2.
      width1=(graphPositionFeature1[fin-1][0]-x1)-LARGEUR
      out.write('''    <rect x="%d" y="%d" width="%d" height="%d" fill="none" stroke="black" stroke-width="2" />'''%(x1,y1,width1,HAUTEUR))
      graphPositionFeature2.append([x1,y1,width1])
   return graphPositionFeature2


def drawInterBlocs2(out,graphPositionFeature2,finalInterBlocs,chromNumber1):
   i=0
   for genome in finalInterBlocs:
      for (x,y) in genome:
         x1=graphPositionFeature2[x-1][0]+LARGEUR
         y1=graphPositionFeature2[x-1][1]-HAUTEUR/2.-INTERVALY*(len(finalInterBlocs)-i)
         width1=(graphPositionFeature2[y-1][0]-x1)-LARGEUR
         if genome[(x,y)]==0:
            out.write('''    <rect x="%d" y="%d" width="%d" height="%d" fill="none" stroke="black" stroke-width="2" />'''%(x1,y1,width1,HAUTEUR))
         elif genome[(x,y)]==1:
            out.write('''    <rect x="%d" y="%d" width="%d" height="%d" fill="grey" stroke="black" stroke-width="2" />'''%(x1,y1,width1,HAUTEUR))
         elif genome[(x,y)]==2:
            out.write('''    <rect x="%d" y="%d" width="%d" height="%d" fill="black" stroke="black" stroke-width="2" />'''%(x1,y1,width1,HAUTEUR))
      i+=1


def footer(out):
   out.write('''\n</svg>\n''')



#lenName
NAMELEN=140
#space between chromosomes
INTERVALY=20
#space between genes (in Genome 1)
INTERVALX=12
#circle
RAYON=3           #RADIUS
#rectangle
HAUTEUR=2*RAYON+2 #HEIGHT
LARGEUR=RAYON+1    #WIDTH
#FONTSIZE=

def syntenyBlocSVG(nameFile,shortName1,chromName1,recapBlocGene1,codeListGenome1,
                   chromNumber1,centroNumber1,nameListGenome1,recapSimilarityG1,
                   shortName2,chromName2,recapBlocGene2,codeListGenome2,
                   chromNumber2,centroNumber2,nameListGenome2,recapSimilarityG2,
                   newPairOfOrthoDico,order,newPairOfHomo3Dico={}):
   Level=INTERVALY*(len(chromName2)+3) # step between the different chromosome of genome 1
   maxLenghtChrom1=n01Genomes.maxLenghtChrom(chromNumber1)
   out=open(nameFile,'w')
   header(out,INTERVALX*maxLenghtChrom1+300,Level*len(chromName1)+100)
   nbCh1=len(chromName1)
   nbCh2=len(chromName2)
   drawStucture(out,Level,shortName1,nbCh1,nbCh2,chromNumber1,shortName2,
                  chromName1,chromName2)
   drawLegende(out)
   (graphPositionFeature1,k,sup)=drawGenome1(0,out,Level,codeListGenome1,
                                             chromNumber1,centroNumber1,
                                             nameListGenome1,recapSimilarityG1)
   drawGenome2(k,out,Level,recapBlocGene1,graphPositionFeature1,recapBlocGene2,
               codeListGenome2,chromNumber2,centroNumber2,nameListGenome2,
               recapSimilarityG2,newPairOfOrthoDico,order,newPairOfHomo3Dico)
   footer(out)
   out.close()


def interBlocSVG(nameFile,genomeNames,shortName1,chromNumber1,centroNumber1,nbCh1,codeListGenome1,nameListGenome1,nbGenome,finalInterBlocs,interBlocsNumber=''):
   Level=INTERVALY*(nbGenome+2) # step between the different chromosome of genome 1
   maxLenghtChrom1=maxLenghtChrom(chromNumber1)
   out=open(nameFile,'w')
   header(out,INTERVALX*(maxLenghtChrom1+22),Level*(len(chromNumber1)+0.5))
   drawStucture(out,Level,shortName1,nbCh1,nbGenome,chromNumber1,chromName2=genomeNames)
   (graphPositionFeature1,k,sup)=drawGenome1(0,out,Level,codeListGenome1,chromNumber1,centroNumber1,nameListGenome1,recapSimilarityG1=[])
   #  (graphPositionFeature2)=drawInterBlocs1(out,graphPositionFeature1,finalInterBlocs)
   print interBlocsNumber
   drawInterBlocs2(out,graphPositionFeature1,finalInterBlocs,chromNumber1)

   footer(out)
   out.close()
