#!/usr/bin/env python 
# -*- coding: utf-8 -*-
###############################################################################
## functions that draw Chromosomal Painting picture

import re,sys,os
import n01Genomes

def header(out,w,h):
   out.write('''<?xml version="1.0" standalone="no"?>
<svg width="%d" height="%d" 
xmlns="http://www.w3.org/2000/svg" version="1.1"
xmlns:xlink="http://www.w3.org/1999/xlink">'''%(w,h))

## draw the chromosome of genome
def drawGenome(out,xg,yg,name,names,genome,end,feats,cs):
   newChromo=[]
   newGenome=[]
   newEnd=[]
   newEndPrev=[]
   for i,n in enumerate(names):
      if i+cs in genome:
         newChromo.append(n)
         newGenome.append(genome[i+cs])
         if i+cs-1 in end:
            newEnd.append(end[i+cs]-end[i+cs-1])
            newEndPrev.append(end[i+cs-1])
         else:
            newEnd.append(end[i+cs])
            newEndPrev.append(0)

   y=yg
   x=xg
   out.write('''    <text x="%d" y="%d" font-family="Verdana" font-size="20" fill="black" > %s </text>\n'''%(x,y-28,name))
   for i,ch in enumerate(newGenome):
      ch10=newEnd[i]
      out.write('''    <text x="%d" y="%d" font-family="Verdana" font-size="15" fill="black" > %s </text>\n'''%(x,y-6,newChromo[i]))
      out.write('''    <rect x="%d" y="%d" width="17" height="%d" fill="none" stroke="black" stroke-width="1" />\n'''%(x,y,(ch10+6)*0.5))
      for bl in ch:
         color=colorS[bl[1]%40]
         #print bl[0],newEndPrev[i],y,y+1+(bl[0]-newEndPrev[i])*0.5
         bl0=bl[0]-newEndPrev[i]
         out.write('''    <rect x="%d" y="%d" width="15" height="1" fill="%s" stroke="none" stroke-width="1" />\n'''%(x+1,y+1+bl0*0.5,color))
      x+=25
   y=yg
   x=xg
   #feats=[('cen',1,373,375),('rDNA',2,215,300),('HML',3,115,117)]
   for feat in feats:
      if feat[1] in newChromo:
         f1=newChromo.index(feat[1])
         if feat[0]=='cen':
            out.write('''    <circle cx="%d" cy="%d" r="7" fill="none" stroke="black" stroke-width="2" />\n'''%(x+9+25*f1,y+1+feat[2]*0.5))
         elif feat[0]=='rDNA':
            out.write('''    <rect x="%d" y="%d" width="20" height="20" fill="none" stroke="black" stroke-width="2" />\n'''%(x-1+25*f1,y-9+feat[2]*0.5))
         else:
            if feat[0]=='Mat':
               cf='black'
            elif feat[0]=='HML':
               cf='lightGrey'
            else:
               cf='white'
            x1,y1,x2,y2,x3,y3=x+25*f1,y+feat[2]*0.5-4,x+25*f1,y+feat[2]*0.5+6,x+16+25*f1,y+1+feat[2]*0.5
            out.write('''    <polygon fill="%s" stroke="black" stroke-width="2" 
            points="%d,%d  %d,%d  %d,%d" />\n'''%(cf,x1,y1,x2,y2,x3,y3))
         
## violet,rouge,orange,jaune,bleu clair,vert,marron,bleu,rose,bordeau,gris,...
#colorS=["#FFFF00","#FF0000","#AAAAFF","#AA55FF","#00FF00","#5500AA","#00AAAA",
#        "#FFAA00","#FFAAFF","#FF55AA","#AAAAAA","#00AAFF","#AA55AA","#AA0000",
#        "#AAFFAA","#AAFF00","#FFFFAA","#000000","#AA5500","#FFAAAA","#55AAFF",
#        "#5500FF","#0055FF"]
colorS=["#550055", "#FF0000", "#FFAA00", "#FFFF00", "#00FFFF", "#00FF00", "#AA5500",
       "#0055FF", "#FFAAAA", "#AA0000", "#AAAAAA", "#AAFFAA", "#AAAA00", "#005500",
       "#550000", "#0000AA", "#AA55FF", "#FF55AA", "#AA0055", "#00AAAA", "#000000",
       "#AA5555", "#00AA00", "#AAFFFF", "#AAAAFF", "#555555", "#FF0055", "#5500FF",
       "#00AAFF", "#FFAAFF", "#55FFAA", "#55AA55", "#005555", "#55AAFF", "#AA55AA",
       "#FFFFAA", "#55AAAA", "#AAFF00", "#FF5555", "#5500AA"]

def footer(out):
   out.write('''
</svg>
''')



def TwoGenomesBlocs(fileName,ref):
   chromos1={}
   chromos2={}
   f=open(fileName,'r')
   f.readline()
   for l in f:
      ll=l.split()
      chr1=int(ll[1]) #chr_id as in .def
      gene1=int(ll[3])
      chr2=int(ll[6])
      gene2=int(ll[8])
      if ref==1:
         chromos1.setdefault(chr1,[]).append((gene1,chr1-1))
         chromos2.setdefault(chr2,[]).append((gene2,chr1-1))
      elif ref==2:
         chromos1.setdefault(chr1,[]).append((gene1,chr2-1))
         chromos2.setdefault(chr2,[]).append((gene2,chr2-1))
   f.close()
   for c in chromos1:
      chromos1[c].sort() 
   for c in chromos2:
      chromos2[c].sort() 
   return chromos1,chromos2
   
def endChromo(cladeN,name):
   nbl=0
   for l in open('../../'+cladeN+'/01Genomes/'+name+'.def','r'):
      nbl+=1
   expression="nbl="+str(nbl)+r"""; awk -v nbl=$nbl '{if (NR==2) ch=$3; if(NR==nbl) print ch,$9; \
if (NR>2 && ch!=$3) {if ($1=="gene"){print ch,$9-1}else{print ch,$9};ch=$3}}' ../../\
"""+cladeN+"/01Genomes/"+name+".def > chromo"
   os.system(expression)
   chromoList={}
   for l in open('chromo','r'):
      ls=l.split()
      chromoList[int(ls[0])]=int(ls[1])
   os.system("rm -rf chromo")
   return chromoList

def getCen(cladeN,name):
   feats=[]
   if name+'.feat' in os.listdir('../../'+cladeN+'/01Genomes/'):
      for l in open('../../'+cladeN+'/01Genomes/'+name+'.feat','r'):
         ls=l.split()
         feats.append((ls[0],int(ls[1]),int(ls[2])))
   return feats

def chrStart(cladeN,name):
   fileO=open('../../'+cladeN+'/01Genomes/'+name+'.def','r')
   fileO.readline()
   l=fileO.readline()
   ls=l.split()
   return int(ls[2])  

def _main_(argv):
   if len(argv)!=5:
      print "4 (+ 2 optional) arguments are expected:\n\
 -> the organism name (as 'Yeast')\n\
 -> delta\n\
 -> the first shortname (as 'MUSM')\n\
 -> the second shortname (as 'HOMS')\n"
      exit(1)
   cladeN=argv[1]
   delta=argv[2]
   name1=argv[3]
   name2=argv[4]
   feats1=getCen(cladeN,name1)
   feats2=getCen(cladeN,name2)
   i1=chrStart(cladeN,name1)
   i2=chrStart(cladeN,name2)

   listChromoName1,lc,le=n01Genomes.chromosomesLists('../../'+cladeN,name1)
   end1=endChromo(cladeN,name1)
   listChromoName2,lc2,le2=n01Genomes.chromosomesLists('../../'+cladeN,name2)
   end2=endChromo(cladeN,name2)
   os.system('mkdir ../../'+cladeN+'/11Blocks/Delta'+delta+'/G1fG2')
   out=open('../../'+cladeN+'/11Blocks/Delta'+delta+'/G1fG2/'+name2+'.'+name1+'f'+name2+'.'+delta+'.svg','w')
   
   if name1<name2:
      ref=2
   else:
      ref=1
      name1,name2=name2,name1
      i1,i2=i2,i1
   ch1,ch2=TwoGenomesBlocs('../../'+cladeN+'/11Blocks/Delta'+delta+'/RBHBlocks/'+name1+'.'+name2+'.rbh.pairs',ref)

   end1L=end1.values()
   end1L.sort
   h=end1L[0]
   for e in range(1,len(end1L)):
      h=max(h,end1L[e]-end1L[e-1])
   end2L=end2.values()
   end2L.sort
   for e in range(1,len(end2L)):
      h=max(h,end2L[e]-end2L[e-1])
   header(out,400+(len(ch1)+len(ch2))*25,150+h*0.5)
   
   if ref==2:
      drawGenome(out,50,90,name2,listChromoName2,ch2,end2,feats2,i2)
      drawGenome(out,150+len(ch2)*25,90,name1,listChromoName1,ch1,end1,feats1,i1)
   else:
      drawGenome(out,50,90,name1,listChromoName2,ch1,end2,feats2,i1)#20,-1000
      drawGenome(out,150+len(ch1)*25,90,name2,listChromoName1,ch2,end1,feats1,i2)#4000,-1000
   #drawGenome(out,3020,0,'ancestor '+name+' '+fileName,ch3)
   footer(out)
   out.close()

#_main_([0,'Vertebrate','5','HOMS','DANR',1,1])
#_main_([0,'Yeast','5','LAKL','SACE',0,0])
if __name__=="__main__":
   _main_(sys.argv)


